
word inbox --- simple inbox, any non-zero is received as a character (use $100 etc to send a null)
--- simple receive routine reads the inbox and only clears it when it is non-zero (avoids r/w clash)
: GETMAIL ( -- char )   inbox W@ DUP IF inbox W~ THEN >B ;

word outbox
--- simple blocking send routine will wait until the outbox is externally cleared before sending
: SENDMAIL ( char -- )  BEGIN outbox W@ 0= UNTIL $100 OR outbox W! ;

--- redirect all input and output to a mailbox
: MAIL    ' GETMAIL ukey W! ' SENDMAIL uemit W! ;
