TAQOZ ( Primary kernel extensions )


FORGET STRIPIT




pub STRIPIT ( nameptr -- nameptr+ )
	SPACE DUP C@++ $1F AND CTYPE			--- Ok, strip it out
	DUP DUP C@ $1F AND 3 + ( 1 ANDN ) ( nameptr cnt )
	DUP >L @WORDS +
	@WORDS ROT SWAP - ( newnames len )
	@WORDS ROT ROT <CMOVE
	L> DUP names W+! +   	 			--- add to names pointer and to current pointer for next word
 	;

--- Strip a single header from the dictionary
pre STRIP ( <name> -- )			[C] NFA' [G] STRIPIT DROP ;

--- RECLAIM memory by striping private headers from the dictionary
--- RECLAIM <opt>
pre RECLAIM ( <to> -- )
	delim 1+ C@ $20 = IF [C] NFA' [G] ELSE $10.0000 THEN ( to )
	4 REG W~
	CRLF CRLF '{' EMIT
	@WORDS DUP >L
	BEGIN
	( to words )
	  2DUP >
	  OVER W@ AND
	WHILE

	  --- Test to see if ATR is private
  	  DUPC@ $40 AND
  	     --- strip header or proceed to next
  	    IF 4 REG W@ 10 // 0= IF CRLF THEN STRIPIT 4 REG W++ ELSE NFA+ THEN
	REPEAT
	--- Report results
	DROP CRLF ." Reclaimed " @WORDS L> DUP >L  - DUP .DECL PRINT"  bytes"
	--- Clear the reclaimed area (not needed really )
	L> SWAP ?DUP IF ERASE ELSE DROP THEN
\	CRLF [C] WORDS
	CRLF '}' EMIT DROP
	;





	*** SERIAL RAM ***

pub *SPIRAM*		PRINT" LY68L6400 8MB SPI RAM ACCESS 191020-0000" ;
{
LY68L6400 8MB SPI RAM

$03	READ
$0B	FAST READ
$02	WRITE
$66	RESET ENABLE
$99	RESET
$C0	SET BURST LENGTH
$9F	READ ID

}


ALIAS SFC@ SRC@
ALIAS SFW@ SRW@
ALIAS SF@ SR@
ALIAS SF SR

pub SRRD				3 SFCMD SPIWM ;
pub !SR					$66 SFCMD SPICE $99 SFCMD SPICE ;
pub SRWRP ( src dst -- )		2 SFCMD SPIWM 512 SPITX SPICE ;
pub SRWRS ( hub srdst bytes -- )	ROT SWAP ADO I OVER SRWRP 512 + 512 +LOOP DROP ;
pub SRC!				2 SFCMD SPIWM SPIWB SPICE ;
pub SRW!				2 SFCMD SPIWM DUP SPIWB 8>> SPIWB SPICE ;
pub SR!					2 SFCMD SPIWM 4 FOR DUP SPIWB 8>> NEXT DROP SPICE ;
pub SRID				$9F SFCMD 0 SPIWM 0 SPIRL 0 SPIRL ;
pub .SR					SRID SWAP .L SPACE .L ;


0	:= srinc
pub SRRDS ( srsrc hubdst bytes -- )
	BEGIN
	  3RD SRRD 	\ $0B SFCMD SPIWM 0 SPIRD DROP
	  DUP 1024 MIN AT srinc 2+ !
	  OVER srinc SPIRX SPICE DROP
	  ROT srinc + ROT srinc + ROT srinc -
	  DUP 0=
	UNTIL 3DROP
	;


\ pub FCACHE 				@FILE 0 $800000 ADO DUP SECTOR I CRLF OVER .L SPACE DUP .L SPACE SRWRP 1+ 512 +LOOP DROP ;

--- routine to cache 8MB of a file into SPI RAM
pub FCACHE				@FILE 0 $80.0000 9 >> FOR OVER SECTOR OVER SRWRP b++ 512 + NEXT 2DROP ;


{
SFJID	$EF40_1400	EF WINBOND 40 TYPE  14 W25Q80
#EF
SRID	$0D5D_46A0 $2A46_5C34		0D LYONTEK 5D KGD=PASS




}


{ MEASURE PIN CAPACITANCE AS A FLOAT TO HIGH TIME }
: ?PIN ( pin --  )
	CRLF ." P" DUP . 9 EMIT
	PIN
	0 8 FOR L 100 us F CNT@ BEGIN R UNTIL CNT@ SWAP - ABS + NEXT 3 >>
	10 U.R
	;
: ?PINS ( from for -- ) ADO I ?PIN LOOP ;


pri CRLF+		CRLF 2 SPACES ;

pub .MODULES
	@WORDS
	BEGIN
	  DUP W@
	WHILE
	  DUP MOD?
	    IF CRLF+ DUP .NFA CR TAB TAB DUP CFA EXECUTE
	  THEN
	  NFA+
	REPEAT
	DROP
	;

pub .ASBYTES		.DECL ."  bytes" ;


\ pub lsi2c	128 FOR I 2* I2CRD? IF I 2* .B SPACE THEN NEXT I2C> ;
pri .I2C ( dev -- )
	AT i2cdev C!
	i2cdev I2CRD? 0EXIT
	CRLF i2cdev 2 SPACES .B
	i2cdev SWITCH 2 TABS
	$A4 CASE PRINT" RV-3028 RTC" BREAK
	$A0 CASE PRINT" EEPROM" BREAK
	CASE@ $C0 $DE WITHIN IF PRINT" Si5351A CLOCK GEN" BREAK
	CASE@ $30 $3E WITHIN IF PRINT" MCP9808 TEMPERATURE SENSOR" BREAK

\	$C4 CASE PRINT" Si5351A-B0448 CLOCK GEN" BREAK
	CASE@ $40 $4E WITHIN IF PRINT" I/O EXPLANDER" BREAK
	PRINT" UNKNOWN DEVICE"
	;
pub lsi2c	PRINT" I2C DEVICES"	$80 FOR I 2* .I2C NEXT ;
pub SFBYTES	SFJID 8>> >B |< ;
pri .UBYTES	SWAP .ADRX 2 SPACES .ASBYTES ;
pub .USAGE
	CRLF PRINT" MEMORY MAP"
	CRLF+ PRINT" CODE:" 		2 TABS HERE HERE .UBYTES
	CRLF+ PRINT" WORDS:" 		2 TABS @WORDS " END" SEARCH 6 +  @WORDS - .UBYTES
	CRLF+ PRINT" DATA:" 		2 TABS org@   org@ AT orglen 6 - CALL @ - .UBYTES
	HERE 16>> 0=
	IF
	  CRLF+ PRINT" ROOM:" 		2 TABS @WORDS HERE - 7 SPACES .ASBYTES
	THEN
	;
pub .DEVICES
	CRLF PRINT" DEVICES"
---	SD
	SD? IF CRLF+ PRINT" SD CARD"	2 TABS sdsize @ 512 1,000,000,000 */ . PRINT" GB  " .CARD THEN
---	SPI FLASH
	SFJID 16 >> $FFFF <> IF CRLF+ PRINT" SPI FLASH" 	2 TABS SFBYTES .MEM SPACE
	SFJID 24 >> $EF = IF PRINT" WINBOND" ELSE ." UNKNOWN" THEN  SPACE SFJID .L SPACE SFSID '#' EMIT D. THEN
---	SPI RAM
	SRID DROP 24 >> $0D = IF CRLF+ PRINT" SPI RAM"		2 TABS SRID SWAP .L SPACE .L THEN
---	I2C
	CRLF lsi2c
	;
pub SYSINFO
	CRLF PRINT" KERNEL" 		2 TABS .VER
	PRINT" MODULES:" 		2 TABS .MODULES
	.USAGE
	CRLF PRINT" HARDWARE"
	CRLF+ PRINT" PCB"		2 TABS 4 8 CTYPE $A4 I2CRD? IF PRINT" (P2D2)" THEN
	CRLF+ PRINT" CLOCK IN"		2 TABS _xin @ 2 .DP PRINT" MHZ"
	.DEVICES

	RTC? IF  CRLF TAB TAB .FDT THEN
	CRLF
	;

ALIAS SYSINFO ??

	*** SHORTCUTS ***

pri ~Y		wORDS CRLF PROMPT ; 	AT ~Y ^Y CTRL!
pri ~?		.USAGE CRLF PROMPT ;	AT ~? ^? CTRL!
pri ~W		W CRLF PROMPT ; 	AT ~W ^W CTRL!
pri ~D		DEBUG CRLF PROMPT ;	AT ~D ^D CTRL!
pri ~B		BU CRLF PROMPT ;	AT ~B ^B CTRL!

--- capture rx buffers into $70000 stacked, then erase buffers
pri ~E		$70000 $70300 $0C00 <CMOVE $7F500 $70000 $300 CMOVE $7F500 $300 ERASE ."  SAVED " ; AT ~E ^E CTRL!



--- perform SYSINFO one second after powerup (allows for USB connection etc)
pub MAIN	FORTH 1000 ms KEY 1 <> 0EXIT DISCARD   SYSINFO ;

AUTO MAIN
RECLAIM STRIPIT

END
