TAQOZ

IFDEF *WORDMIX*
FORGET *WORDMIX*
}
pub *WORDMIX*	PRINT" WORDMIX - a graphical game for the P2 " ;

{
Locate a random 6-letter word in the dictionary and display the mixed VOCAB to the user
while displaying all the blank positions for combinations of those VOCAB that make up 3 to 6 letter words

}
IFNDEF $+!
pub $+! ( ch str -- )	DUP LEN$ + W! ;
}
pub &		AND ;
pub !&		NOT AND ;
pub >=<		WITHIN ;

\ pub RANDOM ( from to -- n )	RND SWAP 1+ // + ;

$60000 := VOCAB
long threes
long fours
long fives
long sixes

long threecnt
long fourcnt
long fivecnt
long sixcnt

pub WORDMIX
	" WORDMIX.TXT" FOPEN$ @FILE VOCAB @FSIZE @ SDRDS
---	find pointers to each letter size section
	VOCAB BEGIN C@++ 6 = UNTIL 1+ DUP sixes !
	BEGIN C@++ 5 = UNTIL 1+ DUP fives !
	BEGIN C@++ 4 = UNTIL 1+ DUP fours !
	BEGIN C@++ 3 = UNTIL 1+ DUP threes !
	BEGIN C@++ 0= UNTIL 1+ threes @ - 3 / threecnt !
	threes @ fours @ - 2- 4 / fourcnt !
	fours @ fives @ - 2- 5 / fivecnt !
 	fives @ sixes @ - 2- 6 / sixcnt !
{
	CRLF sixes @ .L SPACE sixcnt @ .
	CRLF fives @ .L SPACE fivecnt @ .
	CRLF fours @ .L SPACE fourcnt @ .
	CRLF threes @ .L SPACE threecnt @ .
}
	;

7 bytes master
7 bytes mixer
7 bytes mixed
7 bytes guess
7 bytes matcher

--- print mixed word
pub .MIX
	mixed 6 CTYPE
	;

--- match string with master
pub MATCH? ( str cnt -- flg )
	matcher 6 ERASE
	matcher SWAP CMOVE
	master mixer 6 CMOVE
--- eliminate letters from matcher with mixer - all eliminated in matcher = match
	mixer 6 ADO
	  I C@ matcher 6 ADO I C@ OVER = IF I C~ DROP 0 LEAVE THEN LOOP
	    IF LEAVE THEN
	  LOOP
	matcher @ matcher W@ OR 0=
	;

pub COMPARE$ ( str1 str2 len -- flg )
	FOR OVER I+ C@ OVER I+ C@ <> IF 2DROP UNLOOP 0 EXIT THEN NEXT 2DROP TRUE
	;


--- is guess a real word in the VOCAB?
pub WORD? ( -- flg )
---	select section of vocab
	guess LEN$ 3 - 4 * threes + @ ( vocab  )
	BEGIN
	  DUP C@ $40 >
	WHILE
	  DUP guess DUP LEN$ COMPARE$ ?EXIT
	  guess LEN$ +
	REPEAT
	DROP FALSE
	;



--- MIX UP THE LETTERS OF THE MASTER WORD
pub MIX
	BEGIN
	  master mixer 6 CMOVE mixed 7 ERASE
	  BEGIN
	    mixer @ mixer 4+ W@ OR
	  WHILE
	    RND 6 // mixer + DUP C@ IF DUP C@ mixed $+! C~ ELSE DROP THEN
	  REPEAT
	  master mixed $= NOT
	UNTIL
	;

--- select a character from the mix and add that to the guess
pub SELECT ( ch -- )
	mixed 6 ADO I C@ OVER = IF DUP guess $+! LEAVE THEN LOOP DROP
	;

--- submit a guess
pub SUBMIT

	;

pub FINDMIXES
	sixes @ sixcnt @ 6 * ADO I 6 MATCH? IF I 6 CTYPE THEN 6 +LOOP
	fives @ fivecnt @ 5 * ADO I 5 MATCH? IF I 5 CTYPE THEN 5 +LOOP
	sixes @ sixcnt @ 4 * ADO I 4 MATCH? IF I 4 CTYPE THEN 4 +LOOP
	sixes @ sixcnt @ 3 * ADO I 3 MATCH? IF I 3 CTYPE THEN 3 +LOOP
	;

pub NEWGAME
	WORDMIX
	CNT@ $29 COG!	( seed )
	RND sixcnt @ // 6 * sixes @ + master 6 CMOVE
	master 6 CTYPE
	MIX
	SPACE .MIX
	;



END
