TAQOZ

pub *MORSE*	  PRINT" Morse code keyer 210316-2130 " ;
{
210314  Using Scroungre method to encode a character
        in one byte using a start bit and up to 7 symbols
}

pri dotms ( len -- )        50 * ms ;
800 := _pitch

{ The character speed is related to dot length in seconds
by the following formula: Speed (WPM) = 2.4 * dots/sec
}
pub WPM ( wpm -- )	1200 SWAP / AT dotms C! ;
pub PITCH ( hz -- )	600 MAX 1000 MIN AT _pitch :=! ;

--- Lookup morse code for characters ! to Z
0 TABLE _morse
!"#$_      %1101011 | %1010010  | 0         | %10001001 |
%&'(_      0        | %101000   | %1011110  | %110110   |
)*+,_      %1101101 | 0         | %101010   | %1110011  |
-./_       %1100001 | %1010101  | %110010   |
0..3_      %111111  | %101111   | %100111   | %100011   |
4..7_      %100001  | %100000   | %110000   | %111000   |
8..9_      %111100  | %111110   |
:;<=_      %1111000 | %1101010  | 0         | %110001   |
>?@_       0        | %1001100  | %1011010  |
A..D_      %101     | %11000    | %11010    | %1100     |
E..H_      %101     | %10010    | %1110     | %10000    |
I..L_      %100     | %10111    | %1101     | %10100    |
M..P_      %111     | %110      | %1111     | %10110    |
Q..T_      %11101   | %1010     | %1000     | %11       |
U..X_      %1001    | %10001    | %1011     | %11001    |
Y..Z_      %11011   | %11100    |

pri GAP ( len -- )
    @PIN $3F > IF DROP $20 CONEMIT
    ELSE MUTE dotms THEN
    ;
pri TAP: ( rdy val -- rdy val )
    OVER
    IF @PIN $3F > IF DUP 1& " .-" + C@ CONEMIT
    ELSE _pitch HZ  DUP 1& 1+ 1 OR dotms 1 GAP THEN
--- Activate ready once a start bit is detected
    ELSE DUP 1& ROT OR SWAP
    THEN
    ;

--- Switch character output to morse keyer
pub MORSE ( pin/code -- )
	PIN EMIT:
pub TAP ( ch -- )
	DUP $20 >
	IF --- convert lower case to upper case & offset
	  $7F AND a>A
--- is it in the table?
	  DUP '!' 'Z' WITHIN
--- offset into table lookup and prep msb to lsb first
        IF '!' - _morse + C@ REV 24 >> ( prep code )
--- reset start flag and scan all 8 bits to tap up to 7 symbols
        0 SWAP 8 FOR TAP: 2/ NEXT THEN
        2DROP 3
	ELSE
	  DROP 7
	THEN
	GAP
	;

{
Usage: 0 MORSE PRINT" HELLO WORLD" CON
294 bytes ( old method 444 bytes )
}
END
