TAQOZ ( 636 bytes )
IFDEF *PS2*
	kbs org
	FORGET *PS2*
}
pub *PS2*	PRINT" PS/2 KEYBOARD " ;


			*** PS/2 KEYBOARD ***



private
long kbs
\ 0 |<	:= caps	--- caps lock
\ pri lsk		2 ;	\ 1 |<	:= lsk	--- left shift key
\ pri rsk		4 ;	\ 2 |<	:= rsk	--- right shift key
\ pri lck		8 ;	\ 3 |<	:= lck	--- left ctrl
\ pri rck		$10 ;	\ 4 |<	:= rck	--- right ctrl
\ pri lak		$20 ;	\ 5 |<	:= lak	--- left alt
\ pri rak		$40 ;	\ 6 |<	:= rak	--- right alt

2 longs kbk	--- sequence of KEY# codes - lsb = latest

{
$14	left ctrl
$58	caps
$12	LEFT SHIFT
$59	RIGHT SHIFT
$11	LEFT ALT
$E0 11	RIHT ALT

}
256 TABLE kbtbl

public
12250 := kbb --- my keyboard baud rate ( typical 10 KHz to 16.7 KHz)

--- setup P7 for PS/2 keyboard data
pri !KEYB			KBDAT PIN 0 WRPIN F R 0EXIT 9 -bit kbb RXD H ;
--- receive PS/2 data from smartpin and right justify
pri RXKB ( -- KEY# )		KBDAT PIN R IF RDPIN 23 >> ELSE 0 THEN >B ;


pri MAKE?			kbk 1+ C@ $F0 <> ;
pri KBRK ( mask -- )		kbs MAKE? IF SET ELSE CLR THEN 0 ;

--- get KEY#ode but process and filter break codes
pri KEY#@
	RXKB DUP 0EXIT
	DUP SWITCH kbk kbk 1+ 7 <CMOVE kbk C!	\ kbk @ 8<< OR kbk !
	$14 CASE 8 KBRK BREAK	--- left ctrl
	$12 CASE 2 KBRK BREAK	--- left shift
	$59 CASE 4 KBRK BREAK	--- right shift
	$58 CASE MAKE? IF kbs C@ 1 XOR kbs C! THEN 0 BREAK --- caps lock
---	ignore break codes and keys          use key  else no key
	kbk 1+ C@ $F0 <> kbk C@ $F0 <> AND IF kbk C@  BREAK
	0
	;



pub KEYB
	KEY:
--- select PS/2 keyboard in tandem with console as input
pri KEYB@
---	KEY#ode + shift
	KEY#@ kbs C@ 6 AND IF $80 + THEN
---	lookup      and apply shift if necessary
	kbtbl + C@   DUP 'a' 'z' WITHIN kbs C@ 1& AND IF $20 - THEN
---	and trim if left control pressed
	8 kbs SET? 0EXIT $1F AND
	;




pub CONKEYB		KEY: KEYB@ DUP ?EXIT DROP CONKEY ;
pub PC			CONKEYB CONVGA ;

( configure TAQOZ to use VGA and PS/2 keyboard for its console - as well as the serial input )
pub P2PC
	!KEYB PC -MAC CLS &100.100 vint W! -C64
	8 SPACES ." PARALLAX P2 TAQOZ PC " 8 SPACES
	SD? IF MOUNT -MAC DIR THEN -MAC
	;


{
--- TESTING WORDS
: DKB		KEY: KEYB@ DROP CONKEY ;
: L		kbk 4 + @ .L SPACE kbk @ .L ;
}
{
16 bytes kbbuf
byte kbw
byte kbr
: KBPOLL	KEYB@ ?DUP IF kbbuf kbw C@ >N + C! kbw C++ THEN ;
: KBTASK	!KEYB kbw W~ BEGIN KBPOLL AGAIN ;
: KB		KEY: kbr C@ >N kbw >N C@ <> IF kbr C@ >N kbbuf + C@ kbr C++ ELSE CONKEY THEN ;
}

--- temporary table building words
pub KEY^				$80 +
pri KEY#	( ascii KEY# -- )	>B kbtbl + C! ;

( LOWER CASE )
'a' $1C KEY#	'b' $32 KEY#	'c' $21 KEY#	'd' $23 KEY#
'e' $24 KEY#	'f' $2B KEY#	'g' $34 KEY#	'h' $33 KEY#
'i' $43 KEY#	'j' $3B KEY#	'k' $42 KEY#	'l' $4B KEY#
'm' $3A KEY#	'n' $31 KEY#	'o' $44 KEY#	'p' $4D KEY#
'q' $15 KEY#	'r' $2D KEY#	's' $1B KEY#	't' $2C KEY#
'u' $3C KEY#	'v' $2A KEY#	'w' $1D KEY#	'x' $22 KEY#
'y' $35 KEY#	'z' $1A KEY#
( UPPER CASE )
 'A' $1C KEY^	'B' $32 KEY^	'C' $21 KEY^	'D' $23 KEY^
 'E' $24 KEY^	'F' $2B KEY^	'G' $34 KEY^	'H' $33 KEY^
 'I' $43 KEY^	'J' $3B KEY^	'K' $42 KEY^	'L' $4B KEY^
 'M' $3A KEY^	'N' $31 KEY^	'O' $44 KEY^	'P' $4D KEY^
 'Q' $15 KEY^	'R' $2D KEY^	'S' $1B KEY^	'T' $2C KEY^
 'U' $3C KEY^	'V' $2A KEY^	'W' $1D KEY^	'X' $22 KEY^
 'Y' $35 KEY^	'Z' $1A KEY^
( NUMBERS )
 '1' $16 KEY#	'2' $1E KEY#	'3' $26 KEY#	'4' $25 KEY#
 '5' $2E KEY#	'6' $36 KEY#	'7' $3D KEY#	'8' $3E KEY#
 '9' $46 KEY#	'0' $45 KEY#
( SYMBOLS )
 '!' $16 KEY^	'@' $1E KEY^	'#' $26 KEY^	'$' $25 KEY^
 '%' $2E KEY^	'^' $36 KEY^	'&' $3D KEY^	'*' $3E KEY^
 '(' $46 KEY^	')' $45 KEY^	 '~' $0E KEY^	'`' $0E KEY#
 '-' $4E KEY#	'_' $4E KEY^	'=' $55 KEY# 	'+' $55 KEY^
 '[' $54 KEY#	'{' $54 KEY^	']' $5B KEY#	'}' $5B KEY^
 '\' $5D KEY#	'|' $5D KEY^	';' $4C KEY#	':' $4C KEY^
 ''' $52 KEY#	'"' $52 KEY^	',' $41 KEY#	'<' $41 KEY^
 '.' $49 KEY#	'>' $49 KEY^	'/' $4A KEY#	'?' $4A KEY^
( CONTROLS )
 $0D $5A KEY#	$0D $5A KEY^	$20 $29 KEY#	$20 $29 KEY^
 $1B $76 KEY#	$08 $66 KEY#	$09 $0D KEY#	$09 $0D KEY^

 ( F1 to F12 )
 $F1 $05 KEY#	$F2 $06 KEY#	$F3 $04 KEY#	$F4 $0C KEY#
 $F5 $03 KEY#	$F6 $0B KEY#	$F7 $F3 KEY#	$F8 $0A KEY#
 $F9 $01 KEY#	$FA $09 KEY#	$FB $78 KEY#	$FC $07 KEY#


( NUM PAD ) ( still needs to have num lock select function )
$90 $7E KEY#   --- SCROLL
$91 $77 KEY#   --- NUM LOCK
'+' $79 KEY#   --- NUM+
'*' $7C KEY#   --- NUM*
'-' $7B KEY#   --- NUM-
'.' $71 KEY#   --- NUM. DEL
'0' $70 KEY#   --- NUM0 INS
'1' $69 KEY#   --- NUM1 END
'2' $72 KEY#   --- NUM2 DOWN
'3' $7A KEY#   --- NUM3 PG DN
'4' $6B KEY#   --- NUM4 LEFT
'5' $73 KEY#   --- NUM5
'6' $74 KEY#   --- NUM6 RIGHT
'7' $6C KEY#   --- NUM7 HOME
'8' $75 KEY#   --- NUM8 UP
'9' $7D KEY#   --- NUM9 PG UP


{
$E0 $1F 	\ LEFT WIN
$E0 $27		\ RIGHT WIN
$E0 $2F		\ LIST
$E0 $5E		\ WAKE UP
$E0 $3F		\ SLEEP
$E0 $37		\ POWER
$E0 $4A		\ NUM/
$E0 $12		\ DOWN
$E0 $14		\ RIGHT CTL
$E0 $23		\ MUTE
$E0 $34		\ PLAY
$E0 $44		\ STOP
}

FORGET KEY^

--- define function key shortcuts
pub :FC		ls ;
pub :FB		DIR ;
pub :F5		" SPIDEY" VIEW$ ;
pub :F6		" MCQUEEN" VIEW$ ;

}
END
