TAQOZ

(       DECOMPILER     )


IFDEF dflg
	dflg org
	FORGET dflg
}

0 TABLE dflg 0 ||

private
20 bytes ifs
byte ex		--- exit flag
byte ind
word wcode		--- current wordcode
word wnfa		--- NFA of current decomps
word wptr
word wsrc


pri dflg?	 1 dflg SET? ;
pri eflg?	 2 dflg SET? ;

pri @SEE++	2
pri @SEE+	wptr W+! ;
pri @SEE	wptr W@ ;
pri SEE@	@SEE W@ ; \ wcode W@ ;

--- create a temporary dummy def so that we can find the CFAs for unnamed words
: T BEGIN $1234 $12345678 UNTIL uemit $0FF " STRING" ;
' T 16 + W@		--- address and read " string literals
' T 14 + W@		--- 10-bit literal
' T 12 + W@		--- register offset
' T 10 + W@		--- address and read UNTIL
' T 4 + W@		--- address and read a LONG literal
' T W@			--- address and read a WORD literal
FORGET T		--- discard temp def and now use parameters for constants
:= (W)			--- 16-bit WORD
:= (L)			--- 32-bit LONG
8>> := (IF)		--- IF or UNTIL branch
8>> := (R)		--- 8-bit register offset
10 >> := (S)		--- 10-bit literal
:= (")

--- find .AS" runtime cfa
: T EXIT .AS" ##" ;
' T 2+ W@ ' T W@
FORGET T
:= (EXIT)
:= (AS)

--- find ." runtime cfa using temp def
: T ." HELLO WORLD! " ;
' T W@
FORGET T
:= (.")

--- find cfa for a long constant
' SDBUF W@ := (LC)
(LC) 1-	:= (DS)

pri 'EMIT	''' EMIT ;
pri $		'$' EMIT ;
pri .D		SPACE '(' EMIT DUP . ')' EMIT
\ pri .ASC	SPACE DUP $20 $7E WITHIN IF 'EMIT EMIT 'EMIT ELSE DROP THEN ;
pri .ASC	SPACE $20 MAX $7F MIN EMIT ;
pri .W:		CRLF .WORD ." : " ;

pri .STR	'"' EMIT SPACE @SEE++ @SEE PRINT$ '"' EMIT @SEE LEN$ 1+ 2 ALIGN @SEE+ ;
pri INDENT	ind C@ 0 MAX SPACES ;
pri +ind	2 ind C+! ;
pri -ind	ind C@ IF -2 ind C+! THEN ;

--- print value of 10-bit encoded literal
pri .W10	SEE@ $3FF AND
pri .LIT	dflg? IF DUP 11 > IF DUP . 3 SPACES DUP DUP 16 >> IF .L ELSE .W THEN .ASC  ELSE .  THEN ELSE . THEN ;

--- add an IF branch to address so that indentation and a THEN can be added
--- and the address to the ifs array
pri +if ( addr -- )
	2 dflg SET? IF DUP ."  (+" .W ." ) " THEN
	ifs ifs 2+ 18 <CMOVE ifs W!
\	4 dflg SET? IF ifs 10 DUMPW THEN
	;

pri -if ( addr -- )
	2 dflg SET? IF DUP ."  (-" .W ." ) " THEN
	ifs 20 ADO DUP I W@ = IF 0 I W! LEAVE THEN 2 +LOOP DROP
\	4 dflg SET? IF ifs 10 DUMPW THEN
	;

pri if? ( addr -- flg )
---	find matching address and clear with flag else loop and exit false
	ifs 20 ADO DUP I W@ = IF ( 0 I W! ) UNLOOP EXIT THEN 2 +LOOP DROP 0
	;


--- forward address referenced?
pri fad? ( addr -- flg )
	0 ifs 20 ADO OVER I W@ <= OR 2 +LOOP NIP
	;

pri ?CRLF	dflg? 0= IF CRLF INDENT THEN ;

pri .LCON	PRINT" := " @SEE 2+ @ .LIT 6 @SEE+ ;



pri ?GOTO
	8 dflg CLR
---	jump bit set? (only valid for a threaded call adddress, not asm or encoded)
	SEE@ 1& SEE@ ' SPACE $F800 WITHIN AND
	IF
---	check if this might be jump because it is an ELSE
	  @SEE 2+ if? ( ptr cfa flg ) @SEE SEE@ U< AND
	  IF @SEE 2+ -if PRINT" ELSE " SEE@ 1 ANDN +if
	  ELSE
---	$491A $4917 T $491A $4917
	  ( ptr cfa ) SEE@ @SEE > @SEE SEE@ > AND
	    IF PRINT" REPEAT " ELSE ( PRINT" GOTO" ) 8 dflg SET THEN
	  THEN
	  dflg? IF SEE@ 1 ANDN DUP CFA>NFA 0= IF .W SPACE ELSE DROP THEN  ( ptr cfa ) THEN
---	set ex termination flag if not a forward reference AND not nested
	  @SEE fad? NOT ind C@ 6 < AND IF ex C++ THEN
	THEN
	;


pri ?DOS
	0 ' FOR CASE? ' DO CASE? ' ADO CASE? IF +ind THEN
	;
pri ?LOOPS
	0 ' NEXT CASE? ' ?NEXT CASE? ' LOOP CASE? ' +LOOP CASE? IF -ind THEN
	;

pri .SEE ( cfa -- )
	SWITCH
	?LOOPS
	dflg? IF CASE@ .WORD SPACE INDENT ELSE SPACE THEN
	?GOTO
	( pc code )
\	SWITCH
	?DOS
	(.") CASE	PRINT" PRINT" .STR BREAK
	(") CASE	.STR BREAK
	(AS) CASE	PRINT" AS" .STR BREAK
	(W) CASE	@SEE++ SEE@ .LIT @SEE++ BREAK
	(L) CASE	.LCON BREAK
	(DS) CASE	.LCON ex C++ BREAK
	(LC) CASE	.LCON ex C++ BREAK

	SEE@ 10 >> (S) = IF .W10 @SEE++ BREAK

	' CASE 6 - CASE	." CASE=" @SEE++ BREAK

	(EXIT) CASE	DUP fad? NOT IF PRINT" ;" ex C++ ELSE PRINT" EXIT" THEN @SEE++ BREAK
---	decoded wordcodes $F800->$FFFF
        CASE@ 8>> SWITCH
	(R) CASE	PRINT" REG " SEE@ .B @SEE++ BREAK
---	conditional?     forward IF or back UNTIL ?
	(IF) CASE	?CRLF SEE@ $80 AND 0=
	    IF
	      PRINT" IF" +ind
---	      next   find branch address and remember
	      @SEE 2+ SEE@ >B 2* + DUP +if
	    ELSE
	      PRINT" UNTIL"
	      @SEE 2+ SEE@ $7F AND 2* -
	    THEN
	 ( branch )
	  dflg? IF SPACE .W ELSE DROP THEN @SEE++ BREAK

---	default for anything other threaded code
	SEE@ DUP $7FF > IF 1 ANDN THEN CFA>NFA ?DUP IF .NFA THEN
	8 dflg SET? IF ."  ; " THEN
	@SEE++
;


pri ?THENS
---	  display  non-code THEN(s) for matching IF(s) using the ifs table
	BEGIN @SEE if?
	WHILE dflg?
	  IF CRLF 10 SPACES -ind INDENT ELSE -ind THEN
	  PRINT"  THEN" ?CRLF
	  @SEE -if
	REPEAT
	;

pri .NAME ( nfa -- )
	CRLF DUP .W:
	DUP C@ $40 AND IF PRINT" pri " THEN
	DUP C@ $80 AND IF PRINT" pre " THEN
	DUP C@ 5 >> 0= IF PRINT" pub " THEN
	.NFA ?CRLF
	;
pri ?NAME
	@SEE CFA>NFA ?DUP IF .NAME THEN
	;


pub SEECFA ( cfaptr --  )
	DUP wsrc W! wptr W!			--- save ptr - use @SEE to read pointer
	ifs 24 ERASE		--- clear all variables
	4 ind C!
	@SEE ' SPACE U< IF ."  *CODE* " DROP BREAK
	BEGIN
	  @SEE 1 ANDN wptr W!
	  ?NAME
	  ex C~
	  ?THENS
---	  Print address
	  dflg? IF @SEE .W: THEN
	  SEE@ .SEE
---	  terminate if flagged or a key pressed
	  ex C@ KEY OR
---	  but not if it still has a forward reference to resolve
	  @SEE fad? NOT AND
---	  but always if we are now reading nulls
	  SEE@ 0= OR
---	 terminate if that was an EXIT and no further nesting
	  @SEE 2- W@ (EXIT) = ind C@ 5 < AND OR
	UNTIL
	CRLF 6 SPACES @SEE wsrc W@ - . ."  bytes "
	;


pre SEE
	[C] NFA' [G] 1 dflg SET
pub SEENFA ( nfa -- )
	?DUP
	IF
	  DUP wnfa W!
\	  DUP .NAME ?CRLF
	  CPA W@ SEECFA
	  CRLF
	ELSE PRINT"  not found "
	THEN
	;

pre DECOMP
	[C] NFA' [G] 1 dflg CLR SEENFA
	;

\ : SEEALL  @WORDS BEGIN DUP C@ WHILE DUP SEES CPA 2+ REPEAT DROP ;
{

pub TR1 DUP IF 2* ELSE 1+ THEN ---
pub TR2 PRINT ;
pub TR3 BEGIN 1+ DUP C@ WHILE 1+ REPEAT ;
}

END

{
IFDEF RECLAIM
RECLAIM dflg
}
