TAQOZ

( ...*.*.. ******** )
( ....*... ..**..** )
( .******. .**..**. )
( **.**.** **..**.. )
( *..**..* *..**..* )
( ******** ..**..** )
( .*....*. .**..**. )
( ***..*** ******** )

( .**..**. ........ )
( .**..**. ........ )
( ..****.. ........ )
( ...**... ........ )
( ........ ........ )
( ........ ........ )
( ........ ........ )
( ........ ........ )
.
create sprites
$FF33 , $66CC , $9933 ,
$66FF , $1408 , $7EDB ,
$99FF , $42E7 , $6666 ,
$3C18 , $0000 , $0000 ,

: dvar
  <builds , ,
  does>
;

: d@ dup @ swap 2+ @ ;
: d! >r r 2+ ! r> ! ;
: hi@ 2+ @ ;

0 var fuel
0 var level
10 var x 5d dvar y
0 var ox 0d dvar oy
1 var drift 0d dvar vel
5000 const g
0 var gameover
17 var platform
64 const thrust

clock i@ var seed
: rnd ( range -- rnd )
  seed @ 1+ 75 * dup
  seed ! u* swap drop
;

160 bytes surface

	 : regolith ( y end strt)
  do
    i over plot
    dup i surface c!
    2 rnd dup + 1- +
    151 min 120 max
  loop
; ( -- y')

: landscape
  126 rnd 1+
  dup platform !
  32 rnd 120 + 1 pen
  over 0 regolith
  over surface over 32
  swap fill
  2dup at
  0 $808 3 0 blts
  160 rot 32 +
  regolith drop
;

: velo
  vel d@ 100 u* drop
  swap 100 u* swap drop
  +
;

: status
  40 0 at fuel @ 3 .r
  120 0 at velo 4 .r
;

: init
  level @ 1+ dup level !
  dup 30 * rnd neg
  500 + 100 max fuel !
  dup 2 * rnd swap -
  dup 0= - drift !
  -8 dup ox ! 0d oy d!
  128 rnd 16 + x !
  0 20 y d! 0 gameover !
  sprites $1808 0 tile
;
	 : wrapBlt ( t dim x y--)
  dup -7 < if
    and and and drop ;s
  then
  over 152 > if
    over 160 - over at
    >r >r 2dup blt
    r> r>
  then
  at blt
;

: mvship
  1 $808 2dup
  x @ y hi@ wrapBlt
  ox @ oy hi@ wrapBlt
;

: flame
  x @ y hi@ 8 + at
  2 $808 blt ( erase)
;

: decFuel
  g dup + neg -1
  vel d@ d+ vel d!
  -1 fuel +!
;

: wrapX ( x -- wrappedX)
  dup 0< if
    160 +
  else
    dup 159 > if
      160 -
    then
  then
;

sysvars 11 + const joy

: doKey
  joy ic@ thrust and
  0= 0= fuel @ 0 >
  and dup if
   decFuel
  then
  drift @ x @ +
  wrapX x !
;

: within ( n min max--f)
  >r 1- over < swap
  r> < and
;
	 : landing?
  y hi@ 8 +
  x @ dup platform @
  dup 24 + within if
    surface c@ 2dup 1-
    > if
      9 + < velo 200 <
      and 2+ gameover !
    else
      drop drop
    then
  else
    surface c@ > if
      2 gameover !
    then
  then
;

: doVel
   vel d@ y d@ d+ y d!
   vel d@ g 0 d+ vel d!
   landing?
;

: frame ( thrust)
  if flame then
  doKey doVel mvship
  status
  clock i@ 2 and and
  dup if flame then
; ( -- thrust')

: luna
  1 vmode cls
  init
  ." Fuel      Vel"
  landscape 0
  begin
    frame
    x @ ox ! y d@ oy d!
    0 pause
  gameover @ until
  drop 40 80 at
  gameover @ 1 = if
    ." WELL DONE!"
  else
    ." CRASH!!!!"
  then
  inkey drop
  key drop 0 vmode
;
