
4  := #vocabs
#vocabs longs vocabs
--- only default FORTH vocab
pub FORTH	vocabs #vocabs 4* ERASE ;



pub @VOCAB ( index -- addr )	4* vocabs + ;

--- push this vocab to the top of the search list
pub +VOCAB ( nfa --- )
	vocabs vocabs 4+ #vocabs 1- 4* <CMOVE
	vocabs !
	;

pub SEARCH-VOCABS ( str -- nfa )
	0 #vocabs
	ADO
	  I @VOCAB @ ?DUP IF OVER SWAP ( str str list ) FIND$ ( str nfa ) DUP ?LEAVE ELSE 0 LEAVE THEN
	LOOP
	( str nfa )
	?DUP IF NIP ELSE @WORDS FIND$ THEN
	;

FORTH

--- Called from vocab control word and links in
pri (VOCAB)
	R> @ NFA+ +VOCAB
	' SEARCH-VOCABS ufind W!
	;

pre VOCAB ( <name> <including> -- )
---	First create a dummy link word with no skip (04)	1
	-4 uwords +! $04_8000 @WORDS !   @WORDS
---	Then create a definition that calls the vocab linking code
	[C] CREATE: AT (VOCAB) HERE 2- W! DUP  HERE ! 4 ALLOT
---	Then calculate the link displacement and update it
	[C] NFA' [G] OVER - SWAP 2+ W!
	;



pub *TIA*	PRINT" TAQOZ INTERACTIVE ASSEMBLER for the PARALLAX P2 - 200327-2300" ;

ALIAS pri #define


public

 	*** fixed data registers ***
AT + COG@ 9 BITS	:= tos
tos			:= a
tos 1+			:= b
tos 2+			:= c
tos 3 +			:= d

( TAQOZ temporary registers )
AT = 1+ COG@ 9 BITS	:= xx
xx 1+			:= yy
xx 2+			:= zz
yy			:= r0
zz			:= r1

r1 1+			:= r2
r2 1+			:= r3
r3 1+			:= r4
xx 1-			:= acc
acc			:= ac

VOCAB ASSEMBLER *TIA*
' ASSEMBLER QD
@WORDS QD
