TAQOZ

pub *MORSE*	PRINT" Morse code keyer 200126-0000 " ;

byte dotms	word _pitch

--- The character speed is related to dot length in seconds by the following formula:
--- Speed (WPM) = 2.4 * (Dots per second)
pub WPM ( wpm -- )	1200 SWAP / dotms C! ;
pub PITCH ( hz -- )	600 MAX 1000 MIN _pitch W! ;

24 WPM 800 PITCH	--- set some defaults

0 TABLE _morse
( A )	%01_11			|| %11_01_01_01		|| %11_01_11_01		|| %11_01_01		||
( E )	%01			|| %01_01_11_01		|| %11_11_01		|| %01_01_01_01		||
( I )	%01_01			|| %01_11_11_11		|| %11_01_11		|| %01_11_01_01		||
( M )	%11_11			|| %11_01		|| %11_11_11		|| %01_11_11_01		||
( Q )	%11_11_01_11		|| %01_11_01		|| %01_01_01		|| %11			||
( U )	%01_01_11		|| %01_01_01_11		|| %01_11_11		|| %11_01_01_11		||
( Y )	%11_01_11_11		|| %11_11_01_01	||

( 1 )	%01_11_11_11_11		|| %01_01_11_11_11	|| %01_01_01_11_11	|| %01_01_01_01_11	||
( 5 )	%01_01_01_01_01		|| %11_01_01_01_01	|| %11_11_01_01_01	|| %11_11_11_01_01	||
( 9 )	%11_11_11_11_01		|| %11_11_11_11_11	||

( . )	%01_11_01_11_01_11	|| %11_11_01_01_11_11	|| %01_01_11_11_01_01	|| %01_11_11_11_11_01	||
( ! )	%11_01_11_01_11_11	|| %11_01_01_11_01	|| %11_01_11_11_01	|| %11_01_11_11_01_11	||
( & )	%01_11_01_01_01		|| %11_11_11_01_01_01	|| %11_01_11_01_11_01	|| %11_01_01_01_11	||
( + )	%01_11_01_11_01		|| %11_01_01_01_01_11	|| %01_01_11_11_01_11	|| %01_11_01_01_11_01	||
( $ )	%01_01_01_11_01_01_11	|| %01_11_11_01_11_01	||

--- Translate the character into a Morse code word composed of 2-bit codes for space/dot/dash
pri MC@ ( ch -- code )
---       0123456789.123456789.123456789.123456789.123456789.123456789.
	" ABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890.,?'!/()&:;=+-_ $@"
	'"' OVER 51 + C! ( TEMPORARY KLUDGE TO EMBED A " INTO THE STRING )
	0 ( ch str cnt ) BEGIN OVER C@ WHILE 3RD 3RD C@ = IF NIP NIP 2* _morse + W@ EXIT THEN 1+ SWAP 1+ SWAP REPEAT
	3DROP 0
	;


pri GAP ( len -- )	@PIN $3F > IF DROP $20 CONEMIT ELSE MUTE dotms C@ * ms THEN ;
pri TAP: ( 0-3 -- ) 	?DUP IF @PIN $3F > IF "  . -" + C@ CONEMIT ELSE _pitch W@ HZ   dotms C@ * ms   1 GAP THEN THEN ;

\ pri GAP			DROP $20 CONEMIT ;
\ pri TAP:		?DUP IF 2/ 1 XOR 1 AND '-' + CONEMIT THEN ;
--- Switch character output to morse keyer
pub MORSE ( pin/code -- )
	PIN EMIT:
pub TAP ( ch -- )
	DUP $20 >
	IF --- convert lower case to upper case & offset
	  $7F AND DUP $5F > IF $20 - THEN
	  --- index morse table and convert 2-bit codes to Morse taps
	  MC@ ?DUP IF 8 FOR DUP 14 >> 3 AND TAP: 2 << NEXT THEN DROP 3
	ELSE
	  DROP 7
	THEN
	GAP
	;

( Usage: 0 MORSE PRINT" HELLO WORLD" CON )

END
