TAQOZ
{
PLEXLED.FTH
SIMPLE CHARACTER I/O FOR P2-ES LED MATRIX
228 bytes of code including table
top view 7 columns x 8 rows
}

IFDEF *PLEXLED*
ledbuf org
FORGET *PLEXLED*
}

pub *PLEXLED*		PRINT" CharliePlexing LED device driver 190714.0000" ;


		*** CHARLIEPLEX DECODE TABLE ***

0 TABLE plx --- create a table for 56 encoded high/low pairs
	$73747576 , $67707172 , $62636465 , $56576061 ,	$51525354 , $45464750 , $40414243 ,
	$34353637 , $27303132 , $23242526 , $16172021 , $12131415 , $05060710 , $01020304 ,

		*** PHYSICAL LED DRIVER ***

--- user can change led display pins on the fly
pub PLEXPIN ( pin -- )	>!
pri leds			8 ;

--- light an LED (only one at a time)
pri XYLED	( x y -- )	3 << + plx + C@ DUP 7 AND leds + LOW 4 >> leds + HIGH ;

		*** LED PIXEL BUFFER ***
private
14 	bytes 	ledbuf	--- holds displayed character + new character to be scrolled in
	byte	scol	--- columns to scroll

--- scroll the matrix by one column left
pri SCROLL		ledbuf 7 ADO I C@ I 7 + C@ 8<< + 2/ DUP I C! 8>> I 7 + C! LOOP ;

		*** LED REFRESH & SCROLLING TASK ***

--- run this task in a cog -
--- NOTE: a background timer could call the central part of this every 1ms and still not notice any flicker
pri PLEX.TASK
	BEGIN
	3 FOR --- scroll counter
	  7 0 DO ledbuf I+ C@
	    8 0 DO DUP I |< AND IF I J XYLED THEN 200 us 0 DIRA COG! LOOP
	  DROP LOOP
	 NEXT
	scol C@ IF scol C-- SCROLL THEN
	AGAIN
	;

	*** PLEXLED CHARACTER OUTPUT DEVICE ***

--- Make the PLEXLED the console output device
pub PLEXLED
	EMIT:
pub PLEXCH ( ch -- )
	1 TASK W@ 0= IF ' PLEX.TASK 1 RUN ledbuf 15 ERASE THEN
---	lookup font and transfer to ledbuf when scrolling is done
	$1C - 7 * FONT5X7 + ledbuf 7 + 7
	  BEGIN scol C@ 0= UNTIL CMOVE
	7 scol C!
	;

 	*** COMBO SERIAL + PLEXLED OUTPUT ***

--- combine the PLEXLED with the serial console
pub CONLED		EMIT: DUP CONEMIT PLEXCH ;


	*** DEBUG words ***
{
: PP ( char -- )	PLEXCH ;
: HELLO			PLEXLED BEGIN ." HELLO WORLD!  "  KEY UNTIL CON ;
: DEMO			PLEXLED BEGIN ."   PARALLAX P2" 2 s KEY UNTIL CON ;
}
END
