pub NOTES ( pin -- )   PIN 3000 100 DO I HZ 50 ms 100 +LOOP MUTE ;


pub NOTES       Create a new public word called NOTES, and start compiling the following code
( pin -- )      ( is a comment up to the matching ), in this case a stack effects comment
                with "pin" as value on the stack when entering, without returning any results.
PIN             Latches the value supplied as the destination for any further PIN type operations.
3000            Not a word, but recognized as the number 3000 which is pushed onto the stack
100             The number 100 is pushed onto the stack over the top of the 3000
DO              Marks the beginning of a loop and takes a starting index (100) and a stop limit (3000)
  I             Returns the value of the current Index starting from 100 (on top of the stack)
  HZ            HZ takes the value from the stack and sets the current PIN to output a matching NCO frequency
  50            50
  ms            will delay 50ms before continuing, long enough to hear a distinct note.
  100           the Hz value we want to step up each time through the loop (100Hz)
+LOOP           Increment the index by the value supplied and loop again until the limit is reached
MUTE            Now to stop that infernal racket, MUTE will simply reset the smartpin function of the pin
;               Exit and return (also completes this word when it is first being created)




pub NOTES ( pin -- )   PIN 3000 100 DO I HZ 10 ms 100 +LOOP MUTE ;


6 PIN 3000 100 DO I HZ 15 I 300 / - ms 100 +LOOP MUTE

6 PIN 3000 100 DO I HZ 15 I 300 / - ms 100 +LOOP MUTE


pub ZAP ( use PIN )    3000 100 DO I HZ 15 I 300 / - ms 200 +LOOP MUTE ;
pub ZAPS ( cnt -- )    FOR ZAP 50 ms NEXT ;
pub SAUCER ( use PIN )  10 FOR 600 Hz 50 ms 580 Hz 50 ms NEXT MUTE ;

pub demo 6 PIN   3000 100 DO   I HZ  50 ms  100 +LOOP   MUTE ;





WS2812

0= 400 hi 800 lo
1= 800 hi 400 lo
rst > 50us

pri wsbit ( bit -- )    1 AND H IF 8 WAITX L 16 ELSE 16 WAITX L 8 THEN WAITX ;


pri wsbit ( bit -- )    1 AND H IF H ELSE L THEN L ;

pub WSLED ( rgb -- )    24 FOR H DUP 1 AND IF H ELSE L THEN L    2/ NEXT DROP 50 us ;


pub WSLED ( rgb -- )    24 FOR DUP 1& IF H H H H H H ELSE H H H L L L THEN L L L 2/ NEXT DROP 50 us ;

pub WSLED ( rgb -- )    @PIN 24 FOR LSBOUT IF H H  ELSE  H L THEN  L NEXT 2DROP 50 us ;




Basic I/O words
These are direct I/O words
LOW ( pin -- )          Drive the pin low
HIGH ( pin -- )         Drive the pin high
FLOAT ( pin -- )        Float the pin
PIN@ ( pin -- state )   Read the pin

These are the PIN I/O words
PIN ( pin -- )          Select a pin
H                       Drive the selected pin high
L                       Drive the selected pin low
F                       Float the selected pin
R ( -- state )          Read the select pin



10 FOR I = 1 TO 10
20 PRINT I; PRINT" SQUARED = ";
30 PRINT I*I
40 NEXT I


1 10 ADO CRLF I .AS" ##\ SQUARED IS = " I I * PRINT LOOP






 .AS" Format string spec:
	#       Convert one digit (default is decimal)
	~       Toggle leading zero suppression
	\       pad leading zeros with spaces
	$|      Hexadecimal
	*|      Convert all remaining digits
	4|      Convert 4 digits

PFLG

|	4
\	2
~	1	Suppress leading zeros

TAQOZ# 12 .AS" 5|" 00012 ok
TAQOZ# 12 .AS" 5|\"     12 ok